///*
 //* lab2_task2bonus.c
 //*
 //* Created: 2019/10/21  19:36:49
 //* Author : ZiyaoWang
 //*/ 

#include <avr/io.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include "util/delay.h"
#define F_CPU 16000000UL
#include <avr/interrupt.h>

static inline void initADC0(void) {
	TCCR1A |= (1 << WGM11) | (1 << COM1A1);
	TCCR1B |= (1 << WGM13) | (1 << WGM12) |(1 << CS11);//set timer1
	ADMUX |= (1 << REFS0); //set voltage on AVCC
	ADCSRA |= (1 << ADPS1) | (1 << ADPS0); //set prescale as 1/8
	ADCSRA |= (1 << ADEN); //enables the ADC
	
	ICR1 = 40000;
}

int main(void)                       
{
	DDRD |= (1 << 3) | (1 << 4);//H-bridge direction control
	DDRD |= (1 << 6);//OCR0A PWM, set PortD.6 output
	PORTD = 0x10;
	TCCR0B = 0x05;//set OCR0A PWM fast PWM, prescale as q/1024 , non-inverted
	TCCR0A = 0x83;
	OCR0A = 0;  // 0% duty cycle
	
	uint16_t potentiometerValue;
	initADC0();//initial the AD converter
	while (1) 
	{
		ADCSRA |= (1 << ADSC); //start ADC conversion
		loop_until_bit_is_clear(ADCSRA, ADSC); //wait until ADC conversion is done
		potentiometerValue = ADC; //read ADC value in
		_delay_ms(3000);
		OCR0A = potentiometerValue/4;//convert the potentiometer value into duty ratio
	}
	return 0;
}