///*
 //* lab2_task3_bonus.c
 //* Created: 2019/10/21 һ 19:36:49
 //* Author : Ziyao Wang
 //*/ 

#include <avr/io.h> //Defines pins, ports, etc.
#include <util/delay.h>

static inline void initADC0(void) {
	ADMUX |= (1 << REFS0); //reference voltage on AVCC, power the AD converter
	ADCSRA |= (1 << ADPS1) | (1 << ADPS0); //set ADC clock prescale as 1/8
	ADCSRA |= (1 << ADEN); //enables the ADC
}

int main(void) {
	uint16_t potentiometerValue;//set the potentiometerValue's data type
	DDRB |= 1 << PINB1; // Set pin 9 to output PWM
	TCCR1A |= (1 << WGM11) | (1 << COM1A1);
	TCCR1B |= (1 << WGM13) | (1 << WGM12) |(1 << CS11);//set PWM mode:FAST PWM, prescale, non-inverted
	ICR1 = 40000;//4. Set ICR1: ICR1 is the top defining PWM period
	initADC0();//initial ADC

	while (1) {
		ADCSRA |= (1 << ADSC); //start ADC conversion
		loop_until_bit_is_clear(ADCSRA, ADSC); //wait until ADC conversion is done
		potentiometerValue= ADC; //read ADC value
	    OCR1A = 4000/1023*potentiometerValue+1000;//convert the potentiometerValue into duty rario, this formula is adjusted according to practice
	}
}