#include <avr/io.h> //Defines pins, ports, etc.
#include <util/delay.h>

static inline void initADC0(void) {
	ADMUX |= (1 << REFS0); //reference voltage on AVCC
	ADCSRA |= (1 << ADPS1) | (1 << ADPS0); //ADC clock prescaler /8
	ADCSRA |= (1 << ADEN); //enables the ADC
}

int main(void) {
	uint16_t potentiometerValue;
	DDRB |= 1 << PINB1; // Set pin 9 to output PWM
	/* 1. Set Fast PWM mode 14: WGM11, WGM12, WGM13 to
	1*/
	/* 2. Set pre-scaleFast PWM mode 14r of 8 */
	/* 3. Set Fast PWM non-inverting mode */
	TCCR1A |= (1 << WGM11) | (1 << COM1A1);
	TCCR1B |= (1 << WGM13) | (1 << WGM12) |(1 << CS11);
	/* 4. Set ICR1: ICR1 is the top defining PWM
	period */
	ICR1 = 40000;
	//int analogread
	/* 5. Set duty cycle, may need offset to correct
	*/
	initADC0();

	while (1) {
		ADCSRA |= (1 << ADSC); //start ADC conversion
		loop_until_bit_is_clear(ADCSRA, ADSC); //wait until ADC conversion is done
		potentiometerValue= ADC; //read ADC value in
	    OCR1A = 4000/1023*potentiometerValue+1000;
	}
}